<template>
  <ul>
    <li
      v-for="(date, i) in computedDates"
      :key="`date-${i}`"
      class="list-complete-item"
    >
      <span class="city" v-if="date.city">{{ date.city }}</span> -
      <span class="location" v-if="date.location">{{ date.location }}</span>
      <br />
      <span class="date" v-if="date.date_start">
        {{ formatDate(date.date_start, date.date_end) }}
      </span>

      <br v-if="date.info" />
      <div class="more-info italic" v-if="date.info" v-html="date.info" />
    </li>
  </ul>
</template>

<script>
import moment from 'moment'
import 'moment/locale/fr'

export default {
  props: {
    dates: {
      type: Array,
      default: null,
    },
    limit: {
      type: Number,
      default: null,
    },
    upcoming: {
      type: Boolean,
      default: false,
    },
  },

  data() {
    return {}
  },

  computed: {
    computedDates() {
      return this.upcoming ? this.upcomingDates : this.sortedDates
    },

    sortedDates() {
      const sDates = this.dates

      sDates.sort(function (a, b) {
        const keyA = new Date(a.date_start)
        const keyB = new Date(b.date_start)

        // Compare the 2 dates
        if (keyA < keyB) return -1
        if (keyA > keyB) return 1

        return 0
      })

      return this.limit && sDates.length > this.limit
        ? sDates.slice(0, this.limit)
        : sDates
    },

    upcomingDates() {
      const today = new Date()
      const sDates = this.dates

      sDates.sort(function (a, b) {
        const keyA = new Date(a.date_start)
        const keyB = new Date(b.date_start)

        // Compare the 2 dates
        if (keyA < keyB) return -1
        if (keyA > keyB) return 1
        return 0
      })

      const arr = sDates.filter(function (date) {
        return moment(today).diff(date.date_start) < 0
      })

      const upcomingDatesArr =
        this.limit && arr.length > this.limit ? arr.slice(0, this.limit) : arr
      if (!upcomingDatesArr.length) {
        this.$emit('noUpcomingDates')
      }
      return upcomingDatesArr
    },
  },

  methods: {
    formatDate(dateStart, dateEnd) {
      moment.locale('fr')

      if (dateEnd) {
        const startMonth =
          moment(dateStart).format('MMMM') !== moment(dateEnd).format('MMMM')
            ? ' ' + moment(dateStart).format('MMMM')
            : ''

        if (moment(dateEnd).diff(dateStart, 'days') > 1) {
          return (
            'Du ' +
            moment(dateStart).date() +
            startMonth +
            ' au ' +
            moment(dateEnd).format('LL')
          )
        } else {
          return (
            moment(dateStart).date() +
            startMonth +
            ' et ' +
            moment(dateEnd).date() +
            ' ' +
            moment(dateEnd).format('MMMM YYYY')
          )
        }
      }

      return moment(dateStart).format('LL')
    },
  },
}
</script>

<style lang="scss" scoped>
ul {
  @apply mt-10 relative flex flex-col w-full items-center;

  li {
    @apply mb-4;
    @apply flex flex-row justify-center items-center w-full;

    .city {
      @apply uppercase;
    }
    .location {
    }
    .date {
      @apply font-bold;
    }
    .more-info {
      :deep(a) {
        text-decoration: underline;
      }
    }
  }
}

.list-complete-item {
  transition: all 400ms ease;
  display: inline-block;
}

.list-complete-enter, .list-complete-leave-to
/* .list-complete-leave-active below version 2.1.8 */ {
  opacity: 0;
  transform: translateY(30px);
}
.list-complete-leave-active {
  position: absolute;
}
</style>
